/*
 * File:   interpolation.cpp
 * Author: beerli
 *
 * Created on November 22, 2016
 */

#include <cstdlib>
#include <fstream>
#include <iostream>
#include <vector>
#include <iterator>
#include <cmath>

// function
double f(double x)
{
    return sin(x*x);
}

// Finding the coefficients of the polynomial
// takes a vector of x/y coordinates and calculates the coefficients
// the result is destroying the input vector!!!!
void newton_coef(std::vector<std::pair<double,double>> &x)
{
    /*order*/ long n = x.size()-1;
    // algorithm from http://stetekluh.com/NewtonPoly.html
    // downloaded November 22, 2016
    //
    // code
    //
}

// calculates the y values for any x using the coefficient vector, works only
// within the bounds of the x coordinates in the coefficient vector
double newton_f(double x, const std::vector<std::pair<double,double>> &c)
{
    //
    // code
    //
    return fa;
}


// Piecewise interpolation of a function specified in x/y coordinates.
//
std::vector< std::pair<double,double> >  interpol(std::vector< std::pair<double,double> > &v, long order)
{
    //
    // code
    //
    return result;
}

/*
 *
 */
int main(int argc, char** argv)
{
    long order=2;
    double PI = 3.14159;
    std::vector< std::pair<double,double> > data;
    std::vector< std::pair<double,double> > r;
    std::ofstream rawoutput("raw.txt");
    for (double x = -PI; x < PI; x+= 2.0*PI/50.)
    {
        std::pair<double,double> pp(std::make_pair(x, f(x)));
        data.push_back(pp);
        rawoutput << pp.first << " " << pp.second << std::endl;
    }
    rawoutput.close();
    r = interpol(data,order);
   
    std::ofstream  output("interpoly.txt");
    if (output.is_open())
    {
        std::vector< std::pair<double,double> >::iterator rit;
        for(rit=r.begin();rit!=r.end();rit++)
        {
            output << rit->first << " " << rit->second << std::endl;
        }
        output.close();
    }
    return 0;
}

