/* 
 * class hierarchy and operator overloading
 * -hierarchy
 * = operator and reference and const issues and this!!
 */

#include <cstdlib>
#include <iostream>

using namespace std;

class Rectangle {
protected:
  double side;
  double height;
public:

  Rectangle() {
  };

  Rectangle(double s, double h) {
    side = s;
    height = h;
  };

  ~Rectangle() {
  };

  double area() {
    return height*side;
  };

  double circumference() {
    return 2.0 * (height + side);
  };
  const Rectangle& operator=(const Rectangle &rhs);
};

const Rectangle& Rectangle::operator=(const Rectangle &rhs) {
  if (this != &rhs) {
    side = rhs.side;
    height = rhs.height;
  }
  return *this;
}


class Square : public Rectangle {
public:

  Square() : Rectangle() {
  };

  Square(double s) {
    side = s;
    height = s;
  };

  ~Square() {
  };

};

/*
 * 
 */
int main(int argc, char** argv) {

  Square s(10.0);
  Rectangle r(10.0, 5.0);
  Rectangle y(5.0, 5.0);
  Rectangle x;
  x = r;
  cout << s.area() << endl;
  cout << r.area() << endl;
  cout << x.area() << endl;
  //cout << z.area() << endl;
  return 0;
}

