// a simple square root calculator
// 
// (c) Peter Beerli, Tallahassee, FL 2016
//
//
// This program is interactive when started with no argument. 
// If a argument is given then it will only return the 
// squareroot of the argument (if it is a number)
// Without an argument it will ask for numbers on the terminal.
//
// We solve: x^2 == number =====> 0 == x^2 - number, our function is
// f(x,a) = x*x - a
//
// Syntax: 
//  squareroot 
//  squareroot number
//
// Pseudocode:
// (we will have two major functions: main() and newton()
// (1)
// newton() takes an argument x and a (a is then number to sqrt(a)
// loop until we have a precision of 0.00001
//         calculate f(x) [this is x*x-a]
//         calculate derivative of f(x) [this is 2*x]
//         calculate new x [x = f(x)/df(x)]
// return x
//    
// (2)
// start main and evaluate whether there is an argument or not
// if there is an argument then
//         call newton(number)
//         print answer and exit
// else
//         loop until "end"
//              Show "Enter a number or the word 'end'
//              read input
//              if input == end
//                  exit
//              else
//                  call newton(number)
//                  print answer
//         end loop
// exit
//
 
