#include <iostream>
#include <vector>
#include <iterator>
#include <numeric>

// ./vec    it uses a size of 1000
// ./vec 3  it uses a size of 3

double myaccumulator(double x, double y)
{
	return x + exp(y)
}

double myproduct(double x, double y)
{
	return log(x) + (log(y);
}


int main(int argc, char **argv)
{
	int arraysize = 1000;

	srandom(time(NULL));

	if (argc > 1 )
	{
		arraysize = std::stol(argv[1]);
	}
	std::vector<double> myvector;
	for (int i=0; i < arraysize; i++)
	{
		double value = static_cast<double>(random())/RAND_MAX;
		myvector.push_back(value);
	}

	std::vector<double>::iterator veciter;
	for(veciter = myvector.begin();
		veciter != myvector.end();
		veciter++)
	{
		std::cout << *veciter << std::endl;
	}

	double sum = std::accumulate(myvector.begin(),myvector.end(),0.0);
	double g   = std::inner_product(myvector.begin(),myvector.end(),myvector.begin(),0.0);
	double h   = std::inner_product(myvector.begin(),myvector.end(),myvector.begin(),0.0, myaccumulator, myproduct);
	
	std::cout << "Sum: " << sum << std::endl;
	std::cout << "multiply add: " << g << std::endl;
	std::cout << "multiply add own function: " << h << std::endl;


}
//use vector class
// fill our vector
// print vector

// sum over all elements 

// inner product of 2 vectors 
