/*
 * von neuman came up with a random number generator:
 * take the middle 8 numbers of X^2 as a random number 
 * and also use them generate the next
 */


#include <iostream>
#include <string>

int main(int argc, char** argv) {

  // take a 8-digit number as the seed
  std::string seed = argv[1];
  // convert the string into a number
  unsigned long x1 = std::stol(seed);
  // loop over 10 numbers
  long n=10;
  for (long i=0; i<n; i = i + 1)
    {
      // multiply with itself
      unsigned long x2 = x1 * x1;
      // take the middle 8 digits out (this is the random number)
      std::string x2s = std::to_string(x2);
      long start = x2s.size()/2 - 4;
      seed = x2s.substr(start,8);
      // use the new 8-digit number as the seed for the next random number 
      x1 = std::stol(seed);
      // print out result
      std::cout <<  x1 << std::endl;
    }
  return 0;
}
