/* 
 * class hierarchy and operator overloading
 * -hierarchy
 */

#include <cstdlib>
#include <iostream>

using namespace std;

class Rectangle {
protected:
  double side;
  double height;
public:

  Rectangle() {
  };

  Rectangle(double s, double h) {
    side = s;
    height = h;
  };

  ~Rectangle() {
  };

  double area() {
    return height*side;
  };

  double circumference() {
    return 2.0 * (height + side);
  };
};



/*
 * 
 */
int main(int argc, char** argv) 
{
  Rectangle s(5.0, 10.0);
  Rectangle r(10.0, 5.0);
  Rectangle y(5.0, 5.0);
  Rectangle x;
  x = r;
  cout << s.area() << endl;
  cout << r.area() << endl;
  cout << r.circumference() << endl;
  cout << x.area() << endl;
  cout << x.circumference() << endl;
  return 0;
}

