// a simple square root calculator
// 
// (c) Peter Beerli, Tallahassee, FL 2016
//
//
// This program is interactive when started with no argument. 
// If a argument is given then it will only return the 
// squareroot of the argument (if it is a number)
// Without an argument it will ask for numbers on the terminal.
//
// Syntax: 
//  squareroot 
//  squareroot number
//
// the function and its derivative to solve
double myf(double x)
{
  return x*x;
}
double mydf(double x)
{
  return 2*x;
}

// newton() takes an argument x
double newton(double x)
{
  // loop until we have a precision of 0.00001
  double precision = 0.0001;
  double fx = 10000.0;
  double dfx;
  while (fabs(fx) < precision)
    {
      //calculate f(x) [this is x*x]
      fx = myf(x);
      //calculate derivative of f(x) [this is 2*x]
      dfx = mydf(x);
      //calculate new x [x = x - f(x)/df(x)]
      x = x - fx / dfx;
    }
  return x;
}
//    
// (2)
// start main and evaluate whether there is an argument or not
// if there is an argument then
//         call newton(number)
//         print answer and exit
// else
//         loop until "end"
//              Show "Enter a number or the word 'end'
//              read input
//              if input == end
//                  exit
//              else
//                  call newton(number)
//                  print answer
//         end loop
// exit
//
 
