//includes
#include <iostream>
#include<fstream>
#include <vector>
#include <set>
#include <map>
#include <string>
#include <iterator>
#include <functional>
#include <algorithm>


// general functions



// main
int main(int argc, char **argv)
{
	std::string myfilename = "alice.txt";
	
	if (argc > 1)
	{
		myfilename = argv[1];
	}	

	std::vector<std::string> text;
	std::ifstream myfile(myfilename);
	if(myfile.is_open())
	{
		std::string word;
		while (myfile >> word)
		{
			word.erase(std::remove_if(word.begin(),word.end(),std::not1(std::ptr_fun(&isalpha))),word.end());
			text.push_back(word);
		}
		myfile.close();	
	}
	std::sort(text.begin(),text.end());	
	std::vector<std::string>::iterator textit;

	std::map<std::string, int> textmap;
	std::map<std::string,int>::iterator mapit;
	for (textit = text.begin(); textit != text.end();textit++)
	{
		std::string key = *textit;
		mapit = textmap.find(key);
		if(mapit != textmap.end())
		{
			mapit->second += 1;
		}
		else
		{	
			textmap.insert(std::make_pair(key,1));
		}
	}	

	std::ofstream output("output.txt");
	if (output.is_open())
	  {
	    std::vector<std::pair<int, std::string>> result;
	    for (mapit = textmap.begin(); mapit != textmap.end();mapit++)
	      {
		std::pair<int,std::string> a(mapit->second,mapit->first);
		result.push_back(a);
	      }
	    std::sort(result.begin(),result.end());
	    std::vector<std::pair<int, std::string>>::iterator rit;
	    for(rit=result.begin();rit!=result.end();rit++)
	      {
		output << rit->first << " " << rit->second << std::endl;	
		
	      }
	    output.close();
	  }
}

